(** Time-stamp: <modified the 19/08/2008 (at 16:41) by Erwan Jahier> *)

open CompiledData



(* XXX use Map.t 

   We have Two kind of substitutions. 

   - One is used to deal with the clock name binding, to relate node
   parameters and node arguments.

   - The other one is used to deal with polymorphic clock
   variables. Indeed, constant clock is intrinsically
   polymorphic. Hence, when clocking a contant (e.g., "42"), we
   return the clock_info Ci_var i, where i is a fresh
   integer. Afterwards, when encoutering an expression such as
   "42+x", where we know the clock of x (clk_x), we produce the
   substitution (i,clk_x).

   XXX Shouldn't I merge the 2 kind of substitutions ?  That would
   mean I need to invent a fake var_info_eff, but it would make the
   whole more homogeous.

   XXX Make it abstract?
*)
type subst = (Ident.t * Ident.t) list  * (int * clock_eff) list

val empty_subst : subst


val apply_subst:subst -> clock_eff -> clock_eff

(* only apply the part of the subst that deals with clock var *)
val apply_subst2:subst -> clock_eff -> clock_eff

(** Raises an error is the 2 clock_eff are not unifiable *)
val f : Lxm.t -> subst -> clock_eff -> clock_eff -> subst
val list : Lxm.t -> clock_eff list -> subst -> clock_eff * subst


(* Stuff to generated fresh var clocks  
   XXX bad place, bad name
*)
val reset_var_type : unit -> unit
val get_constant_clock : unit -> clock_eff
val get_var_type : unit -> int
